import { HTTPClient } from "koajax";
import { ListModel } from "mobx-restful";
export const congressClient: HTTPClient<import("koajax").Context>;
export interface Session extends Record<'chamber' | 'startDate' | 'endDate', string> {
    type: 'R';
    number: number;
}
export interface Congress extends Record<'name' | 'startYear' | 'endYear', string>, Partial<Record<'updateDate' | 'url', string>> {
    sessions: Session[];
}
declare const CongressModel_base: (abstract new (...args: any[]) => {
    stream?: AsyncGenerator<Congress, void, any>;
    openStream(filter: Partial<import("mobx-restful").NewData<Congress>>): AsyncGenerator<Congress, void, any>;
    clearList(): void;
    clear(): void;
    restoreList({ filter, pageIndex, pageSize, allItems, totalCount }?: Partial<Pick<ListModel<Congress, Partial<import("mobx-restful").NewData<Congress>>>, "filter" | "pageIndex" | "pageSize" | "allItems" | "totalCount">>): Promise<void>;
    loadStream(filter: Partial<import("mobx-restful").NewData<Congress>>, newCount: number): Promise<Congress[]>;
    loadPage(pageIndex: number, pageSize: number, filter: Partial<import("mobx-restful").NewData<Congress>>): Promise<{
        pageData: Congress[];
        totalCount: number;
    }>;
    pageIndex: number;
    pageSize: number;
    filter: Partial<import("mobx-restful").NewData<Congress>>;
    totalCount: number | undefined;
    pageList: Congress[][];
    readonly currentPage: Congress[];
    readonly pageCount: number;
    readonly allItems: Congress[];
    readonly noMore: boolean;
    statistic: Partial<Record<import("web-utility").TypeKeys<Congress, import("web-utility").IndexKey>, Record<string, number>>>;
    turnTo(pageIndex: number, pageSize?: number): ListModel<Congress, Partial<import("mobx-restful").NewData<Congress>>>;
    loadNewPage(pageIndex: number, pageSize: number, filter: Partial<import("mobx-restful").NewData<Congress>>): Promise<{
        pageData: Congress[];
        totalCount: number;
    }>;
    getList(filter?: Partial<import("mobx-restful").NewData<Congress>>, pageIndex?: number, pageSize?: number): Promise<Congress[]>;
    refreshList(): Promise<Congress[]>;
    getAll(filter?: Partial<import("mobx-restful").NewData<Congress>>, pageSize?: number): Promise<Congress[]>;
    countAll(keys: import("web-utility").TypeKeys<Congress, import("web-utility").IndexKey>[], filter?: Partial<import("mobx-restful").NewData<Congress>>, pageSize?: number): Promise<Partial<Record<import("web-utility").TypeKeys<Congress, import("web-utility").IndexKey>, Record<string, number>>>>;
    indexOf(id: import("mobx-restful").IDType): number;
    changeOne(data: Partial<Congress>, id: import("mobx-restful").IDType, patch?: boolean): void;
    updateOne(data: Partial<import("mobx-restful").NewData<Congress>>, id?: import("mobx-restful").IDType): Promise<Congress>;
    removeOne(id: import("mobx-restful").IDType): Promise<void>;
    deleteOne(id: import("mobx-restful").IDType): Promise<void>;
    client: import("mobx-restful").RESTClient;
    baseURI: string;
    indexKey: keyof Congress;
    currentOne: Congress;
    clearCurrent(): void;
    getOne(id: import("mobx-restful").IDType): Promise<Congress>;
    downloading: number;
    uploading: number;
}) & import("web-utility").AbstractClass<ListModel<Congress, Partial<import("mobx-restful").NewData<Congress>>>>;
export class CongressModel extends CongressModel_base {
    baseURI: string;
    client: import("koajax").HTTPClient<import("koajax").Context>;
    accessor thisYearOne: Congress | undefined;
    openStream(): AsyncGenerator<Congress, void, unknown>;
    getOne(id: number): Promise<Congress>;
    getThisYearOne(): Promise<Congress>;
}

//# sourceMappingURL=index.d.ts.map
